! 4006, sbay flows scaled, no-flux bc, sal and uu only
! --set up for management runs

      program salmodel

      integer day_begin, days_run, dt, day, day_of_run
      real*8  calib_Eu(2,51), calib_Ew(51), Eu(2,51), Ew(51), Nu(51) 
      real*8  ap(2,51), au(2,51), aw(2,51), deltxp(51), deltxu(51)
      real*8  aztool(51), deltzw(51), hp(51), hu(51), widthav(2,51)
      real*8  u2_table(51,5), rel_table(5), salocean(24380)
      real*8  evaporat(24380), precipit(24380), std_el(24380)
	real*8	sui2win(24380), sfo2win(24380)
      real*8  af(24380), df(24380), gcf(24380)
      real*8  salp(2,51), uu(2,51)
      real*8  saloldp(2,51), npf(24380)
      real*8  qevapp(51), qprecipp(51), qrivp(2,51), denp(2,51)
      real*8  speedu(51), utideu(51)
      real*8  qau(51), qu(2,51), qw(51)
	real*8	sedp(2,51)
      real*8  gcfcal, delbedh(2,51)
	real*8  storesalp1(24380,51), storesalp2(24380,51)
	real*8  storeuu1(24380,51), storeuu2(24380,51)
	real*8  storesedp1(24380,51), storesedp2(24380,51)
	real*8  beddelev1(24380,51), beddelev2(24380,51)
	real*8	suisunsed, spbsed, ssbsed, cbsed
	real*8	ggflux, storemalflxin(24380), storeggflx(24380)
	real*8	baysed(24380), storemalflxout(24380),malfluxout
	real*8	suwetsink(24380), spwetsink(24380),storenetmalflx(24380)
	real*8	cbwetsink(24380), sswetsink(24380)
	real*8	netmass(2,51)
	real*8	storemass1(24380,51), storemass2(24380,51)
	real*8	suspenmass(24380),wetloss(24380)
	real*8	ssmalflux(24380),freessc(24380)
	real*8	ssbreg(14)
	real*8	guadload(24380),quitoload(24380),alamload(24380)
	real*8	napload(24380),wnutload(24380)
	real*8	tribload(24380)
	real*8	sbayload(24380),spbload(24380),suiload(24380),cbload(24380)
	real*8	sbssc(2),cbssc(2),spbssc(2),suissc(2)
	real*8	storesbssc(24380,2), storecbssc(24380,2)
	real*8	storespbssc(24380,2), storesuissc(24380,2)

      open(unit=1, file='inputs/calib40.dat', status='unknown')
      read(1,*) dum1, dum2, gcfcal
	day_begin = int(dum1)
	days_run = int(dum2)
      do 100 i=1,51
         read(1,*) calib_Eu(1,i), calib_Eu(2,i), calib_Ew(i)
 100  continue
      close(1)


!
! input: bathymetry; tabular tidal data; oceanic salinity; evaporation;
! precipitation; Delta and South Bay river flow; the standard deviation -
! relative to average - of the Golden Gate water level variations; a 
! calendar; and a start_up file for salp and uu.
!
      open(unit=1, file='inputs/bathymetZ.dat', status='unknown')
      do 200 i=1,51
         read(1,*) ap(1,i), ap(2,i), au(1,i), au(2,i), aw(1,i),aw(2,i),
     &             deltxp(i), deltxu(i), deltzw(i), hp(i), hu(i),
     &             widthav(1,i), widthav(2,i), aztool(i)
 200  continue
      close(1)

      open(unit=1, file='inputs/tidetabl.dat', status='unknown')
      do 240 i=1,51
         read(1,*) u2_table(i,1), u2_table(i,2), u2_table(i,3), 
     &        u2_table(i,4), u2_table(i,5)
 240  continue

      read(1,*) rel_table(1), rel_table(2), rel_table(3), rel_table(4), 
     &          rel_table(5)
      close(1)

      open(unit=1, file='inputs/sa4006.dat', status='unknown')
      open(unit=2, file='inputs/ev4006.dat', status='unknown')
      open(unit=3, file='inputs/pr4006.dat', status='unknown')
      open(unit=4, file='inputs/ti4006.dat', status='unknown')
	open(unit=5, file='inputs/win4006.dat', status='unknown')
	open(unit=6, file='inputs/fpt4006.dat', status='unknown')
	open(unit=7, file='inputs/wet4006.dat', status='unknown')
	open(unit=8, file='inputs/trib4006.dat', status='unknown')
      do 260 i=1,24380
		read(1,*) salocean(i)
          read(2,*) evaporat(i)
		read(3,*) precipit(i)
		read(4,*) std_el(i)
		read(5,*) sui2win(i), sfo2win(i)     ! units are in m2/s2
		evaporat(i) = evaporat(i) * 2.94e-7  ! convert evap & precip
		precipit(i) = precipit(i) * 2.94e-7  ! from in/day to m/s
		read(6,*) freessc(i)
		read(7,*) suwetsink(i), spwetsink(i), cbwetsink(i), sswetsink(i)
		read(8,*) guadload(i), quitoload(i), alamload(i), 
     &			  napload(i), wnutload(i)
	! convert wetland sinks to g/day from kg/day
		suwetsink(i)=suwetsink(i)*1000.
		spwetsink(i)=spwetsink(i)*1000.
		cbwetsink(i)=cbwetsink(i)*1000.
		sswetsink(i)=sswetsink(i)*1000.
 260  continue
	close(1)
      close(2)
	close(3)
      close(4)
	close(5)
	close(6)
	close(7)
	close(8)

      open(unit=1, file='inputs/f4006.dat', status='unknown')
      do 270 i=1,24380
	   read(1,*) df(i)
	   af(i)=df(i) * 0.0087
	   gcf(i)=df(i) * 0.0082
	   npf(i)=df(i)*5.0/872.0
! Rating curve to calculate the flux of SS at Mallard, metric tons
	   ssmalflux(i)=1.135*0.0007*((df(i)**1.7354)*(freessc(i)**0.5182))
		if (ssmalflux(i).lt.0) then
			ssmalflux(i)=0.
		endif
 270  continue
      close(1)
	

      open(unit=1, file='inputs/init40.dat', 
     &status='unknown')
      do 290 i=1,51
         read(1,*) salp(1,i), salp(2,i), uu(1,i), uu(2,i)
         saloldp(1,i) = salp(1,i)
         saloldp(2,i) = salp(2,i)
 290  continue
      close(1)

!
! overwrite the specified dt to ensure 1 step/day and convert to 
! seconds and initialize the o/p counters, store and store1
!

      dt=1*24*3600


!Initial SSC conditions throughout bay
!units are in mg/L
		do 340 j=1,51
			sedp(1,j)=50.
			sedp(2,j)=50.
 340		continue


!
! begin the simulation. 
!  day=1 for 1/1/40, day_of_run=1 for 1st day of current run
!
      do 1100 day=day_begin, days_run+day_begin-1
         day_of_run = day - day_begin +1
         write(*,*) 'days left:', days_run-day+day_begin
!
! assume evaporation and precipitation to be the same over all segments
! and initialize freshwater runoff
!
         do 400 i=1,51
            qevapp(i)   = evaporat(day)
            qprecipp(i) = precipit(day)
            qrivp(1,i)  = 0.0
            qrivp(2,i)  = 0.0
 400     continue

! Define riverine inputs:
! Delta flow inputs (45), South Bay inputs (Guadelupe and Coyote Rivers
! at (2) and Alameda River at (8)) and estimated Napa River inputs (29)
!
! uncomment for no-flux bc
	   if (df(day).lt.0.) then	
		  gcf(day)=0.
		  npf(day)=0.
		  af(day)=0.
	   endif
!	   qrivp(1,2) =gcfcal*gcf(day)
	   qrivp(1,1) =gcfcal*gcf(day)
	   qrivp(1,8) =af(day)
	   qrivp(1,29)=npf(day)
	   qrivp(1,45)=df(day)


!
! waste (sewage) water inputs
!         qrivp(1,2)=qrivp(1,2)+6.45
         qrivp(1,1)=qrivp(1,1)+6.45
         qrivp(1,3)=1.2
         qrivp(1,8)=qrivp(1,8)+0.9
         qrivp(1,9)=0.6
         qrivp(1,13)=3.8
         qrivp(1,15)=3.2
         qrivp(1,17)=3.8
         qrivp(1,20)=0.73
         qrivp(1,21)=0.45
         qrivp(1,23)=0.36
         qrivp(1,24)=0.16
         qrivp(1,26)=0.16
         qrivp(1,28)=0.13
         qrivp(1,29)=qrivp(1,29)+0.86
         qrivp(1,33)=0.16
         qrivp(1,34)=1.69
         qrivp(1,37)=0.42
         qrivp(1,42)=0.42
         qrivp(1,45)=qrivp(1,45)+7.87
         qrivp(1,49)=0.07
         qrivp(1,50)=0.34

!
! set boundary condition for ocean lower-layer salinity and redefine saloldp
!
         salp(2,46)   =salocean(day)
         saloldp(2,46)=salp(2,46)
!
! compute density in terms of salinity (ignoring temperature dependence here)
!
         do 500 i=1,51
            denp(1,i) = 1000.0*(1.0+saloldp(1,i)*7.8e-4)
            denp(2,i) = 1000.0*(1.0+saloldp(2,i)*7.8e-4)
 500     continue
!
! compute tidal properties of water level amplitude, current speed, bed shear
! stress and tidal energy dissipation
!
         call  tide_var(speedu,u2_table,
     &                   rel_table,std_el(day)) 
!
! convert maximum tidal current speed to m/s and then compute tidally averaged,
! current speed
!
         do 600 i=1,51
            speedu(i)=0.01*speedu(i)
 600     continue
!
         call tide_av(utideu,speedu,uu,au)
!
! evaluate mixing coefficients
!
         call mix_coef(Eu,Ew,Nu,hu,deltxu,deltzw,au,aw,utideu,uu,denp,
     &                    calib_Eu,calib_Ew)
!
! compute flows through the segment faces
!
         call flows(qau,qu,qw,uu,qrivp,qprecipp,qevapp,au,aw,deltxu,
     &                deltxp,hu,denp,widthav,Nu,utideu)
!
! solve for the salt field
!
         call salsolve(salp,qu,qw,Eu,Ew,dt,ap,deltxp,saloldp)
!
! repeat the previous integration using up-dated velocities
!
!
! compute density in terms of salinity (ignoring temperature dependence here)
!
         do 700 i=1,51
            denp(1,i)=1000.0*(1.0+salp(1,i)*7.8e-4)
            denp(2,i)=1000.0*(1.0+salp(2,i)*7.8e-4)
 700     continue
!
! compute tidally averaged velocity
!
         call tide_av(utideu,speedu,uu,au)
!
! evaluate mixing coefficients
!
         call mix_coef(Eu,Ew,Nu,hu,deltxu,deltzw,au,aw,utideu,uu,
     &                  denp,calib_Eu,calib_Ew)
!
! compute flows through the segment faces
!
         call flows(qau,qu,qw,uu,qrivp,qprecipp,qevapp,au,aw,
     &               deltxu,deltxp,hu,denp,widthav,Nu,utideu)

!
! solve for the salt field using up-dated velocities
!
         call salsolve(salp,qu,qw,Eu,Ew,dt,ap,deltxp,saloldp)

!
! solve for the ssc field using up-dated velocities
!


! set boundary condition for ocean lower-layer ssc
         sedp(2,46)=5.7

		call sedsolve(sedp,qu,qw,Eu,Ew,dt,ap,au,aw,aztool,deltxp,hp,
     &        delbedh,day_of_run,utideu,sui2win(day),sfo2win(day),
     &		netmass,ggflux,guadload(day),quitoload(day),alamload(day),
     &		napload(day),wnutload(day),suspenmass(day),
     &		baysed(day),qau,suwetsink(day),spwetsink(day),
     &		cbwetsink(day),sswetsink(day),wetloss(day),ssmalflux(day),
     &		tribload(day),sbayload(day),spbload(day),suiload(day),
     &		cbload(day),malfluxout,sbssc,cbssc,spbssc,suissc)


! 
!
! end the integration
!

!
! store solution ready for the next step
!
         do 800 i=1,51
            saloldp(1,i)=salp(1,i)
            saloldp(2,i)=salp(2,i)
 800     continue

!
! store data for post-run examination
!
         do 900 i=1,51
		   storesalp1(day_of_run,i)=salp(1,i)
		   storesalp2(day_of_run,i)=salp(2,i)
		   storeuu1(day_of_run,i)=uu(1,i)
		   storeuu2(day_of_run,i)=uu(2,i)
		   storesedp1(day_of_run,i)=sedp(1,i)
		   storesedp2(day_of_run,i)=sedp(2,i)
		   beddelev1(day_of_run,i)=delbedh(1,i)
		   beddelev2(day_of_run,i)=delbedh(2,i)
			!unit of mass is metric tons
		   storemass1(day_of_run,i)=netmass(1,i)/1000000.
		   storemass2(day_of_run,i)=netmass(2,i)/1000000.
900      continue

		storesbssc(day_of_run,1)=sbssc(1)
		storesbssc(day_of_run,2)=sbssc(2)
		storecbssc(day_of_run,1)=cbssc(1)
		storecbssc(day_of_run,2)=cbssc(2)
		storespbssc(day_of_run,1)=spbssc(1)
		storespbssc(day_of_run,2)=spbssc(2)
		storesuissc(day_of_run,1)=suissc(1)
		storesuissc(day_of_run,2)=suissc(2)

!
! store SSC flux at mallard island, golden gate, sbregions (kg)
!
		storemalflxin(day_of_run)=ssmalflux(day_of_run)*1000.
		storemalflxout(day_of_run)=malfluxout/1000000.
		storenetmalflx(day_of_run)=ssmalflux(day_of_run)*1000.
     &		-malfluxout/1000.
		storeggflx(day_of_run)=ggflux


!
!
! go to the beginning for another day's simulation
!
 1100 continue

!
! store net basin sedimentation data, in metric tons
! Suisun Bay
!
	   do 1000 i=640,18536
		 do 1001 j=30,38
	       suisunsed=suisunsed+(storemass1(i,j)+storemass2(i,j))
1001		 continue
1000	   continue

!  San Pablo Bay
	   do 1050 i=3927,15979
		 do 1051 j=23,28
	       spbsed=spbsed+(storemass1(i,j)+storemass2(i,j))
1051		 continue
1050     continue


!  South San Francisco Bay
	   do 1060 i=5388,18536
	     do 1061 j=1,4
			ssbsed=ssbsed+(storemass1(i,j)+storemass2(i,j))
1061		 continue
		 do 5061 j=5,8
			ssbsed=ssbsed+(storemass1(i,j)+storemass2(i,j))
5061		 continue
		 do 3061 j=9,11
			ssbsed=ssbsed+(storemass1(i,j)+storemass2(i,j))
3061		 continue
		 do 4061 j=12,14
			ssbsed=ssbsed+(storemass1(i,j)+storemass2(i,j))
4061		 continue
1060     continue

!  South San Francisco Bay, regions 1-4 and wy 56-83
		do 8062 i=5845,15979
			do 8063 j=12,14
				ssbreg(1)=ssbreg(1)+storemass1(i,j)+storemass2(i,j)
8063			continue
			do 8065 j=9,11
				ssbreg(2)=ssbreg(2)+storemass1(i,j)+storemass2(i,j)
8065			continue
			do 8067 j=5,8
				ssbreg(3)=ssbreg(3)+storemass1(i,j)+storemass2(i,j)
8067			continue
			do 8069 j=1,4
				ssbreg(4)=ssbreg(4)+storemass1(i,j)+storemass2(i,j)
8069			continue
8062		continue

!  South San Francisco Bay, regions 1-4 and wy84 to April 5, 2005
		do 8070 i=15980,23837
			ssbreg(5)=ssbreg(5)+storemass1(i,1)+storemass2(i,1)
			ssbreg(6)=ssbreg(6)+storemass1(i,2)+storemass2(i,2)
			ssbreg(7)=ssbreg(7)+storemass1(i,3)+storemass2(i,3)
			ssbreg(8)=ssbreg(8)+storemass1(i,4)+storemass2(i,4)
			ssbreg(9)=ssbreg(9)+storemass1(i,5)+storemass2(i,5)
			ssbreg(10)=ssbreg(10)+storemass1(i,6)+storemass2(i,6)
			ssbreg(11)=ssbreg(11)+storemass1(i,7)+storemass2(i,7)
			ssbreg(12)=ssbreg(12)+storemass1(i,8)+storemass2(i,8)
			ssbreg(13)=ssbreg(13)+storemass1(i,9)+storemass2(i,9)
			ssbreg(14)=ssbreg(14)+storemass1(i,10)+storemass2(i,10)
8070		continue

!  Central San Francisco Bay
	   do 1070 i=5388,18536
	       cbsed=cbsed+storemass1(i,15)+storemass1(i,16)
     &		+storemass1(i,17)+storemass1(i,18)+storemass1(i,19)
     &		+storemass1(i,20)+storemass1(i,21)+storemass1(i,22)
     &		+storemass1(i,49)+storemass1(i,50)+storemass2(i,15)
     &		+storemass2(i,16)+storemass2(i,17)+storemass2(i,18)
     &		+storemass2(i,19)+storemass2(i,20)+storemass2(i,21)
     &		+storemass2(i,22)+storemass2(i,49)+storemass2(i,50)
1070     continue


!
! at end of simulation save stored data files
!

	open(unit=1,file='outputs/ssmalflux.dat',status='new')
!	 Write average SSC 95-01
	do 1057 i=1,days_run
		write(1,2002) ssmalflux(i)
 1057	continue
	close(1)

	open(unit=1,file='outputs/malfluxcomp.dat',status='new')
!	 Write average SSC 95-01
	do 1058 i=1,days_run
		write(1,2004) storenetmalflx(i)
 1058	continue
	close(1)
	
	open(unit=1,file='outputs/basinsed.dat',status='new')
!	Write net basin sedimentation 55-90 in million metric tons
      write(1,2060) suisunsed/1000000., spbsed/1000000., 
     &			  ssbsed/1000000., cbsed/1000000.
      close(1)

	open(unit=1,file='outputs/sbsed5683.dat',status='new')
!	Write South Bay region sedimentation 56-83 in million metric tons
	do 1093 i=1,4
		write(1,2048) ssbreg(i)/1000000.
 1093	continue

 	open(unit=1,file='outputs/sbsed8304.dat',status='new')
!	Write South Bay region sedimentation 56-83 in million metric tons
	do 1056 i=5,14
		write(1,2048) ssbreg(i)/1000000.
 1056	continue

	open(unit=1,file='outputs/basintribload.dat',status='new')
!	Bay basin trib loads, in metric tons
	do 2093 i=1,days_run
		write(1,2060) suiload(i),spbload(i),cbload(i),sbayload(i)
 2093	continue

	open(unit=1,file='outputs/massbalance.dat',status='new')
!	 Write daily mass balance variables to file (in metric tons)
	do 1085 i=1,days_run
		write(1,2047) tribload(i),
     &				  (storemalflxin(i)/1000.),
     &				  storemalflxout(i),
     &				  (storeggflx(i)/1000.),
     &				  wetloss(i),baysed(i),suspenmass(i)
 1085	continue
      close(1)

	open(unit=1,file='outputs/dmb99.dat',status='new')
!	Write box 34 SSC data for all days run to file
      do 1255 i=21459,21823
      write(1,2070) storesedp1(i,4), storesedp2(i,4)
 1255 continue
      close(1)


	open(unit=1,file='outputs/psp99.dat',status='new')
!	Write box 34 SSC data for all days run to file
      do 1258 i=21459,21823
      write(1,2070) storesedp1(i,22), storesedp2(i,22	)
 1258 continue
      close(1)


! Write bed elevation change, in meters

	open(unit=1,file='outputs/bedelevsupper.dat',status='new')
	do 1186 i=1,days_run
      write(1,2001) (beddelev1(i,j), j=1,51)
 1186	continue
      close(1)

	open(unit=1,file='outputs/bedelevslower.dat',status='new')
	do 1187 i=1,days_run
      write(1,2001) (beddelev2(i,j), j=1,51)
 1187	continue
      close(1)

! Write bed mass change, in metric tons

	open(unit=1,file='outputs/netmassupper.dat',status='new')
	do 1188 i=1,days_run
      write(1,2005) (storemass1(i,j), j=1,51)
 1188	continue
      close(1)

	open(unit=1,file='outputs/netmasslower.dat',status='new')
	do 1189 i=1,days_run
      write(1,2005) (storemass2(i,j), j=1,51)
 1189	continue
      close(1)

	open(unit=1,file='outputs/suissc.dat',status='new')
	do 1086 i=21459,21823
		write(1,2070) storesuissc(i,1), storesuissc(i,2)
 1086	continue
	close(1)

	open(unit=1,file='outputs/spbssc.dat',status='new')
	do 1087 i=21459,21823
		write(1,2070) storespbssc(i,1), storespbssc(i,2)
 1087	continue
	close(1)

	open(unit=1,file='outputs/cbssc.dat',status='new')
	do 1088 i=21459,21823
		write(1,2070) storecbssc(i,1), storecbssc(i,2)
 1088	continue
	close(1)

	open(unit=1,file='outputs/sbssc.dat',status='new')
	do 1089 i=21459,21823
		write(1,2070) storesbssc(i,1), storesbssc(i,2)
 1089	continue
	close(1)

!
! end of time-stepping
!

 2000 format (2f8.4)
 2001 format (51f8.4)
 2005 format (51f8.1)
 2010	format (f8.2)
 2002 format (f13.0)
 2003	format (3f8.4)
 2030 format (6f8.4)
 2050	format (2f10.0)
 2060	format (4f10.2)
 2061 format (f8.2)
 2070 format (2f10.1)
 2080	format (5f13.2)
 2047 format (7f13.2)
 2048 format (f13.2)
 2049 format (3f8.2)
 2004 format (2f13.0)

      stop
      end



      subroutine salsolve(salp,qu,qw,Eu,Ew,dt,ap,deltxp,
     &                     saloldp)

      integer dt, indx(102)
      real*8  salp(2,51), qu(2,51), qw(51), Eu(2,51), Ew(51), ap(2,51),
     &        deltxp(51), saloldp(2,51)
      real*8  rhs(102), a(2,51), b(2,51), bstar(2,51), c(2,51), d(2,51)
      real*8  fac, G(102,102)

!
! usage: function [salp]=salsolve(qu,qw,Eu,Ew,dt,ap,...
!				deltxp,saloldp);
!
! Constructs and updates the salinity balance equation using an implicit
! technique with a time-step of 1 day. Performs salt mass-balance check
! if function call not blanked out.
!
! see also: salmodel, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av

!
! initialize variables, fill right hand side of matrix equation and
! integrate over the time-step
!
!
! rhs of matrix equation
!
      do 200 k=1,51
         rhs(k)    = saloldp(1,k)
         rhs(k+51) = saloldp(2,k)
 200     continue
!
         do 250 i=1,51 
            a(1,i) = 0.
            a(2,i) = 0.
            b(1,i) = 0.
            b(2,i) = 0.
            c(1,i) = 0.
            c(2,i) = 0.
            d(1,i) = 0.
            d(2,i) = 0.
            bstar(1,i) = 0.
            bstar(2,i) = 0.
 250     continue
!
! scan the lattice
!
      do 350 i=1,2
         do 300 j=2,50
!
! longitudinal advection
!
            if ((qu(i,j-1).lt.0.).and.(qu(i,j).lt.0.)) then
               a(i,j)=0.0
               b(i,j)=qu(i,j-1)
               c(i,j)=-qu(i,j)
            endif
            if ((qu(i,j-1).gt.0.).and.(qu(i,j).gt.0.)) then
               a(i,j)=qu(i,j-1)
               b(i,j)=-qu(i,j)
               c(i,j)=0.0
            endif
            if ((qu(i,j-1).gt.0.).and.(qu(i,j).lt.0.)) then
               a(i,j)=qu(i,j-1)
               b(i,j)=0.
               c(i,j)=-qu(i,j)
            endif
            if ((qu(i,j-1).lt.0.).and.(qu(i,j).gt.0.)) then
               a(i,j)=0.
               b(i,j)=-qu(i,j)+qu(i,j-1)
               c(i,j)=0.
            endif
!
! vertical advection
!
! upper layer
!
            if (i.eq.1) then
               if (qw(j).gt.0.) then
                  bstar(i,j)=qw(j)
               endif
               if (qw(j).lt.0.) then
                  b(i,j)=b(i,j)+qw(j)
               endif
            endif
!
! lower layer
!
            if (i.eq.2) then
               if (qw(j).lt.0) then
                  bstar(i,j)=-qw(j)
               endif
               if (qw(j).gt.0.) then
                  b(i,j)=b(i,j)-qw(j)
               endif
            endif
!
! longitudinal mixing
!
            a(i,j)=a(i,j)+Eu(i,j-1)
            b(i,j)=b(i,j)-(Eu(i,j-1)+Eu(i,j))
            c(i,j)=c(i,j)+Eu(i,j)
!
! vertical mixing
!
            b(i,j)=b(i,j)-Ew(j)
            bstar(i,j)=bstar(i,j)+Ew(j)
!
! complete equation for point 19.
!
            if (j.eq.19) then
                                !
                                ! longitudinal advection
                                !
               if (qu(i,50).lt.0.) then
                  b(i,19)=b(i,19)+qu(i,50)
               endif
               if (qu(i,50).gt.0.) then
                  d(i,19)=qu(i,50)
               endif 
! d(1,51) occupies column 50 of row 19
! d(2,51) occupies column 50+51 of row 19+51
!
! longitudinal mixing
      
               b(i,19)=b(i,19)-Eu(i,50)
               d(i,19)=d(i,19)+Eu(i,50)
            endif
!
! redo equation for upper layer of point 46 (ocean)
!
! first, longitudinal advection. Ignore (can't define) vertical advection
!
            a(1,46)=0.
            b(1,46)=0.
            c(1,46)=0.
 ! no net advective transport if qu>0
            if (qu(1,46).lt.0.) then
               b(1,46)=qu(1,46)
               c(1,46)=-qu(1,46)
            endif
!
! second, longitudinal mixing
!
            b(1,46)=b(1,46)-Eu(1,46) ! no net mixing to seawards
            c(1,46)=c(1,46)+Eu(1,46)
!
! last, vertical mixing
!
            b(1,46)=b(1,46)-Ew(46)
            bstar(1,46)=Ew(46)
!
! redefine a,b,c,d,bstar
!
            fac=-real(dt)/(ap(i,j)*deltxp(j))
            a(i,j)=fac*a(i,j)
            b(i,j)=1.+fac*b(i,j)
            c(i,j)=fac*c(i,j)
            d(i,j)=fac*d(i,j)
            bstar(i,j)=fac*bstar(i,j)
 300     continue
 350  continue

! boundary conditions at 'p' points 1, 45, 46 and 51
!
      do 400 i=1,2
!
! lines for zero salt flux at 1 (southern South Bay)
!
         a(i,1)=0.
         b(i,1)=1.
         c(i,1)=-1.
         bstar(i,1)=0.
         rhs(1)=0.
         rhs(1+51)=0.


! blank out lines for specified salinity at 1 (southern South Bay)
! (use these if empirical expression in salmodel() is uncommented)
!
!         a(i,1)=0.
!         b(i,1)=1.
!         c(i,1)=0.
!         bstar(i,1)=0.
!
! blank out lines for zero salt flux at 45 (delta)
!
!a(i,45)=-1.
!b(i,45)=1.
!c(i,45)=0.
!bstar(i,45)=0.
!rhs(45)=0.
!rhs(45+51)=0.
!
! lines for zero salinity at 45 (delta)
!
         a(i,45)=0.
         b(i,45)=1.
         c(i,45)=0.
         bstar(i,45)=0.
         rhs(45)=0.
         rhs(45+51)=0.

!
! ocean salinity at 46
!
         a(2,46)=0.
         b(2,46)=1.
         c(2,46)=0.
         bstar(2,46)=0.
!
! put salinity at 51 equal to that at 19
!
         a(i,51)=0.
         b(i,51)=1.
         c(i,51)=0.
         bstar(i,51)=0.
         rhs(51)=0.
         rhs(51+51)=0.
 400  continue

! fill matrix to be inverted
!
      do 550 i=1,102
         do 500 j=1,102
            G(i,j) = 0.0
 500     continue
 550  continue

!upper left
      do 600 k=1,51
         l=k
         G(k,l)=b(1,k)
 600  continue
      do 700 k=2,51
         l=k-1
         G(k,l)=a(1,k)
 700  continue
      do 800 k=1,50
         l=k+1
         G(k,l)=c(1,k)
 800  continue
      G(19,50)=d(1,19)
      G(51,19)=-1.

!upper right
      do 900 k=1,51
         l=k+51
         G(k,l)=bstar(1,k)
 900  continue

!bottom right
	do 1000 k=1+51,51+51
	l=k
	G(k,l)=b(2,k-51)
 1000 continue
      do 1100 k=2+51,51+51
         l=k-1
         G(k,l)=a(2,k-51)
 1100 continue
      do 1200 k=1+51,50+51
         l=k+1
         G(k,l)=c(2,k-51)
 1200 continue
      G(19+51,50+51)=d(2,19)
      G(51+51,19+51)=-1.

!bottom left
      do 1300 k=1+51,51+51
         l=k-51
         G(k,l)=bstar(2,l)
 1300 continue

! invert matrix
!
      call ludcmp(G,indx)
      call lubksb(G,indx,rhs)
      !
! fill salp with updated values
!
 
      do 1400 i = 1,51
         salp(1,i) = rhs(i)
         salp(2,i) = rhs(i+51)
 1400 continue

      return
      end


	    subroutine sedsolve(sedp,qu,qw,Eu,Ew,dt,ap,au,aw,aztool,
     &				deltxp,hp,delbedh,day,utideu,sui2win,
     &				sfo2win,netmass,ggflux,guadload,
     &				quitoload,alamload,napload,wnutload,suspenmass,
     &				baysed,qau,suwetsink,spwetsink,cbwetsink,
     &				sswetsink,wetloss,ssmalflux,
     &				tribload,sbayload,spbload,suiload,cbload,
     &				malfluxout,sbssc,cbssc,spbssc,suissc)		


      integer dt, indx(102), day
      real*8  qu(2,51), qw(51), Eu(2,51), Ew(51), ap(2,51), au(2,51),
     &        deltxp(51), aw(2,51), hp(51), qau(51), aztool(51)
      real*8  rhs(102), a(2,51), b(2,51), bstar(2,51), c(2,51),d(2,51)
      real*8  fac, G(102,102), utideu(51)
	real*8	taub(2),fac1(2),fac2(2),fac2u,fac2l,fac3
	real*8  sedp(2,51), delbedh(2,51), bed_diff2(2,51)
	real*8	stay(2), mass_sed1(2,51),mass_chg
	real*8	sui2win, sfo2win
      real*8  constd, constw, conste(51), n(2)
	real*8	netmass(2,51)
	real*8	chane(51),shale(51),at,as,ac,pt,ps,pc,width1,width2
	real*8	ssmalflux, ggflux, tau1, tau2
	real*8	suspenmass, baysed
	real*8	suwetsink,spwetsink,cbwetsink,sswetsink
	real*8	wetloss
	real*8	beddens(51)
	real*8	guadload,quitoload,alamload,napload,wnutload,tribload
	real*8	sbayload,spbload,suiload,cbload
	real*8	new_vol,old_vol,chgbedh(2,51)
	real*8	vol1,vol2,malfluxout
	real*8	depth1(51), mass
	real*8	sbssc(2),cbssc(2),spbssc(2),suissc(2)
      
	parameter (pi=3.141593)
!
!Calibration coefficients: constd, constw, conste
!	constd = equivalent to the settling velocity
!	constw = weighting factor to balance wind shear and current shear
!	conste = erosion coefficient, tweeking knob to calibrate to net
!		sedimentation

	constd=0.0001		
	constw=0.0001

	do 100 i=1,4		
		conste(i)=0.000353
100	continue		
	do 101 i=5,8		
		conste(i)=0.0003487
101	continue		
	do 102 i=9,11		
		conste(i)=0.0004425
102	continue		
	do 103 i=12,14		
		conste(i)=0.0002658
103	continue		
	do 110 i=23,28		
		conste(i)=0.0000676
110	continue		
	do 120 i=29,45		
		conste(i)=0.0003440
120	continue		
	do 130 i=46,50		
		conste(i)=0.0000502
130	continue		
	do 140 i=15,22		
		conste(i)=0.0000502
140	continue		




! Assign a sediment bed density by sub-embayment (g/m3)

	do 141 i=1,4
		beddens(i)=582400.
 141	continue
	do 1142 i=5,8
		beddens(i)=666600.
 1142	continue
	do 142 i=9,11
		beddens(i)=808000.
 142	continue
	do 143 i=12,14
		beddens(i)=845400.
 143	continue
	do 144 i=15,22
		beddens(i)=996000.
 144	continue
	do 145 i=23,28
		beddens(i)=730000.
 145	continue
	do 146 i=29,45
		beddens(i)=863000.
 146	continue
	do 147 i=46,51
		beddens(i)=996000.
 147	continue
 
! channel/shallow velocity weighting by hydraulic radius (A/Pw)^2/3
!
	do 148 j=1,51
		depth1(j)=ap(1,j)*deltxp(j)/aztool(j)
		width1=aztool(j)/deltxp(j)
		width2=aw(2,j)/deltxp(j)
		as=(width1-width2)*(depth1(j)-delbedh(1,j))
		ac=(hp(j)-5.+depth1(j)-delbedh(2,j))*width2
		at=as+ac
		if (width1.eq.width2) then
			ps=0.
			pc=width2+2*(hp(j)-delbedh(2,j))
			pt=ps+pc
			shale(j)=0.
		else
			ps=2.*(depth1(j)-delbedh(1,j))+(width1-width2)
			pc=width2+2.*(hp(j)-5.-delbedh(2,j))
			pt=ps+pc
			shale(j)=(as/ps)**(2./3.)/(at/pt)**(2./3.)
		endif
		chane(j)=(ac/pc)**(2./3.)/(at/pt)**(2./3.)
 148	continue


! update delbedh to account for sea level rise, 3 mm/yr
!
	do 247 j=1,51
		mass=sedp(1,j)*ap(1,j)*deltxp(j)/depth1(j)
     &		*(depth1(j)-delbedh(1,j))
		delbedh(1,j)=delbedh(1,j)-0.003/365
		sedp(1,j)=mass/(ap(1,j)*deltxp(j)/depth1(j)
     &		*(depth1(j)-delbedh(1,j)))
 247	continue

! update delbedh to account for subsidence 1930-1982
!
	if (day.lt.7579) then			!up to 2 ft (34-60)
		mass=sedp(1,1)*ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1))
		delbedh(1,1)=delbedh(1,1)-0.023/365
		sedp(1,1)=mass/(ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1)))
		
		mass=sedp(1,2)*ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2))
		delbedh(1,2)=delbedh(1,2)-0.017/365
		sedp(1,2)=mass/(ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2)))
		
		mass=sedp(1,3)*ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3))
		delbedh(1,3)=delbedh(1,3)-0.011/365
		sedp(1,3)=mass/(ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3)))
		
		mass=sedp(1,4)*ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4))
		delbedh(1,4)=delbedh(1,4)-0.006/365
		sedp(1,4)=mass/(ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4)))
	elseif (day.lt.10135) then	!up to 1 ft (60-67)
		mass=sedp(1,1)*ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1))
		delbedh(1,1)=delbedh(1,1)-0.038/365
		sedp(1,1)=mass/(ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1)))

		mass=sedp(1,2)*ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2))
		delbedh(1,2)=delbedh(1,2)-0.029/365
		sedp(1,2)=mass/(ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2)))
		
		mass=sedp(1,3)*ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3))
		delbedh(1,3)=delbedh(1,3)-0.019/365
		sedp(1,3)=mass/(ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3)))

		mass=sedp(1,4)*ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4))
		delbedh(1,4)=delbedh(1,4)-0.010/365
		sedp(1,4)=mass/(ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4)))
	elseif (day.lt.15614) then	!up to .1 ft (67-82)
		mass=sedp(1,1)*ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1))
		delbedh(1,1)=delbedh(1,1)-0.002/365
		sedp(1,1)=mass/(ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1)))
		
		mass=sedp(1,2)*ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2))
		delbedh(1,2)=delbedh(1,2)-0.001/365
		sedp(1,2)=mass/(ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2)))

		mass=sedp(1,3)*ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3))
		delbedh(1,3)=delbedh(1,3)-0.001/365
		sedp(1,3)=mass/(ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3)))

		mass=sedp(1,4)*ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4))
		delbedh(1,4)=delbedh(1,4)-0.000/365
		sedp(1,4)=mass/(ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4)))
	elseif (day.gt.15980) then	!estimate of subsidence
		mass=sedp(1,1)*ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1))
		delbedh(1,1)=delbedh(1,1)+0.002/365
		sedp(1,1)=mass/(ap(1,1)*deltxp(1)/depth1(1)
     &		*(depth1(1)-delbedh(1,1)))
		
		mass=sedp(1,2)*ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2))
		delbedh(1,2)=delbedh(1,2)+0.0015/365
		sedp(1,2)=mass/(ap(1,2)*deltxp(2)/depth1(2)
     &		*(depth1(2)-delbedh(1,2)))

		mass=sedp(1,3)*ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3))
		delbedh(1,3)=delbedh(1,3)+0.001/365
		sedp(1,3)=mass/(ap(1,3)*deltxp(3)/depth1(3)
     &		*(depth1(3)-delbedh(1,3)))

		mass=sedp(1,4)*ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4))
		delbedh(1,4)=delbedh(1,4)+0.0005/365
		sedp(1,4)=mass/(ap(1,4)*deltxp(4)/depth1(4)
     &		*(depth1(4)-delbedh(1,4)))
	endif


! add trib load to trib boxes
	! Guadalupe R. and stream group 9
	sedp(1,1)=(sedp(1,1)*ap(1,1)/depth1(1)*(depth1(1)-delbedh(1,1))
     &	*deltxp(1)+1.69*guadload)/(ap(1,1)/depth1(1)
     &	*(depth1(1)-delbedh(1,1))*deltxp(1))
	sedp(1,2)=(sedp(1,2)*ap(1,2)/depth1(2)*(depth1(2)-delbedh(1,2))
     &	*deltxp(2)+1.69*guadload)/(ap(1,2)/depth1(2)
     &	*(depth1(2)-delbedh(1,2))*deltxp(2))
	! San Francisquito Cr.
	sedp(1,3)=(sedp(1,3)*ap(1,3)/depth1(3)*(depth1(3)-delbedh(1,3))
     &	*deltxp(3)+quitoload)/(ap(1,3)/depth1(3)
     &	*(depth1(3)-delbedh(1,3))*deltxp(3))
	! Alameda Cr.
	sedp(1,8)=(sedp(1,8)*ap(1,8)/depth1(8)*(depth1(8)-delbedh(1,8))
     &	*deltxp(8)+alamload)/(ap(1,8)/depth1(8)
     &	*(depth1(8)-delbedh(1,8))*deltxp(8))	
	! Colma Cr.
	sedp(1,12)=(sedp(1,12)*ap(1,12)/depth1(12)*(depth1(12)
     &	-delbedh(1,12))*deltxp(12)+1.29*quitoload)/(ap(1,12)
     &	/depth1(12)*(depth1(12)-delbedh(1,12))*deltxp(12))
	! Remainder of stream group 10
	do 151 j=4,18
		sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)/depth1(j)
     &	  *(depth1(j)-delbedh(1,j))+1.97*quitoload/15.)
     &	  /(ap(1,j)/depth1(j)*(depth1(j)-delbedh(1,j))*deltxp(j))
 151  continue
	! Part of stream group 1
	do 152 j=20,22
		sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)/depth1(j)
     &	  *(depth1(j)-delbedh(1,j))+1.39*quitoload/4.)
     &	  /(ap(1,j)/depth1(j)*(depth1(j)-delbedh(1,j))*deltxp(j))
 152  continue
	! Part of stream group 7
	do 153 j=9,22
		sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)/depth1(j)
     &	  *(depth1(j)-delbedh(1,j))+0.21*alamload/14.)
     &	  /(ap(1,j)/depth1(j)*(depth1(j)-delbedh(1,j))*deltxp(j))
 153	continue
	! Stream group 5 and remainder of stream group 6
	do 154 j=31,38
		sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)/depth1(j)
     &	  *(depth1(j)-delbedh(1,j))+0.90*wnutload/8.)
     &	  /(ap(1,j)/depth1(j)*(depth1(j)-delbedh(1,j))*deltxp(j))
 154	continue
	! Part of stream group 1
	sedp(1,23)=(sedp(1,23)*ap(1,23)/depth1(23)
     &	*(depth1(23)-delbedh(1,23))*deltxp(23)+0.19*napload)
     &	/(ap(1,23)/depth1(23)*(depth1(23)-delbedh(1,23))*deltxp(23))
	! Petaluma R.
	sedp(1,24)=(sedp(1,24)*ap(1,24)/depth1(24)
     &	*(depth1(24)-delbedh(1,24))*deltxp(24)+0.17*napload)
     &	/(ap(1,24)/depth1(24)*(depth1(24)-delbedh(1,24))*deltxp(24))
	! Part of stream group 2
	sedp(1,25)=(sedp(1,25)*ap(1,25)/depth1(25)
     &	*(depth1(25)-delbedh(1,25))*deltxp(25)+0.20*napload)
     &	/(ap(1,25)/depth1(25)*(depth1(25)-delbedh(1,25))*deltxp(25))
	! Sonoma Cr. and other Sonoma drainage
	sedp(1,26)=(sedp(1,26)*ap(1,26)/depth1(26)
     &	*(depth1(26)-delbedh(1,26))*deltxp(26)+0.39*napload)
     &	/(ap(1,26)/depth1(26)*(depth1(26)-delbedh(1,26))*deltxp(26))
	! Napa R. gage and other Napa drainage
	sedp(1,29)=(sedp(1,29)*ap(1,29)/depth1(29)
     &	*(depth1(29)-delbedh(1,29))*deltxp(29)+1.53*napload)
     &	/(ap(1,29)/depth1(29)*(depth1(29)-delbedh(1,29))*deltxp(29))
	! Walnut Cr. and remaining contribution
	sedp(1,34)=(sedp(1,34)*ap(1,34)/depth1(34)
     &	*(depth1(34)-delbedh(1,34))*deltxp(34)+1.50*wnutload)
     &	/(ap(1,34)/depth1(34)*(depth1(34)-delbedh(1,34))*deltxp(34))
	! Part of stream group 1
	sedp(1,50)=(sedp(1,50)*ap(1,50)/depth1(50)
     &	*(depth1(50)-delbedh(1,50))*deltxp(50)+1.39*quitoload/4.)
     &	/(ap(1,50)/depth1(50)*(depth1(50)-delbedh(1,50))*deltxp(50))
	! Set the concentration of 51 equal to that of 19
	sedp(1,51)=sedp(1,19)

		!get SB trib load, in metric tons
	sbayload=(3.38*guadload+(1.+1.97*11./15.+1.29)*quitoload
     &	+(1.+0.21*6./14.)*alamload)/1000000.

	!get SPB trib load, in metric tons
	spbload=(0.19+0.17+0.2+0.39+1.53)*napload/1000000.

	!get Suisun trib load, in metric tons
	suiload=(1.5+0.9)*wnutload/1000000.

	!get CB trib load, in metric tons
	cbload=((1.39+1.97*4./15.)*quitoload+0.21*8./14.*alamload)/1000000.

	!get total bay trib loads, in metric tons
	tribload=sbayload+spbload+suiload+cbload

!
! Set the Delta boundary condition
!
! Set flows to zero and upstream concentrations to zero
	do 156 j=39,45
		sedp(1,j)=0.
		sedp(2,j)=0.
		qu(1,j)=0.
		qu(2,j)=0.
		Eu(1,j)=0.
		Eu(2,j)=0.
		Ew(j)=0.
 156	continue
	Eu(1,38)=0.
	Eu(2,38)=0.


! adjust ssmalflux for sediment budget
	if (day.lt.18537) then
		ssmalflux=0.81*ssmalflux
	else
		ssmalflux=1.09*ssmalflux
	endif
!
! Add mallard mass flux sediment to box 38
! if qu is gt 0, flow is upstream and must account for losses
!
! Define volumes to simplify calculations
	vol1=ap(1,38)*deltxp(38)/depth1(38)*(depth1(38)-delbedh(1,38))
	vol2=ap(2,38)/(hp(38)-5.)*(hp(38)-5.-delbedh(2,38))*deltxp(38)
	if ((qu(1,38).lt.0.).and.(qu(2,38).gt.0.)) then
		sedp(1,38)=(sedp(1,38)*vol1+ssmalflux*1000000.)/vol1
	elseif ((qu(1,38).lt.0.).and.(qu(2,38).lt.0.)) then
		mass_chg=ssmalflux*1000000.*abs(qu(1,38))/abs(qu(1,38)
     &		+qu(2,38))
		sedp(1,38)=(sedp(1,38)*vol1+mass_chg)/vol1
		mass_chg=ssmalflux*1000000.*abs(qu(2,38))/abs(qu(1,38)
     &		+qu(2,38))
		sedp(2,38)=(sedp(2,38)*vol2+mass_chg)/vol2
	endif
!
! initialize variables, fill right hand side of matrix equation and
! integrate over the time-step

!
! rhs of matrix equation
!
      do 240 k=1,51
         rhs(k)    = sedp(1,k)
         rhs(k+51) = sedp(2,k)
 240     continue


         do 250 i=1,51 
            a(1,i) = 0.
            a(2,i) = 0.

            b(1,i) = 0.
            b(2,i) = 0.
            c(1,i) = 0.
            c(2,i) = 0.
            d(1,i) = 0.
            d(2,i) = 0.
            bstar(1,i) = 0.
            bstar(2,i) = 0.
 250     continue
!
! scan the lattice
!
      do 350 i=1,2
         do 300 j=1,50
!
! longitudinal advection
!
		  if (j.eq.1) then
			a(i,1)=0.
			b(i,1)=-qu(i,j)
			c(i,1)=0.
			goto 10
		  endif
            if ((qu(i,j-1).lt.0.).and.(qu(i,j).lt.0.)) then
               a(i,j)=0.0
               b(i,j)=qu(i,j-1)
               c(i,j)=-qu(i,j)
            endif
            if ((qu(i,j-1).gt.0.).and.(qu(i,j).gt.0.)) then
               a(i,j)=qu(i,j-1)
               b(i,j)=-qu(i,j)
               c(i,j)=0.0
            endif
            if ((qu(i,j-1).gt.0.).and.(qu(i,j).lt.0.)) then
               a(i,j)=qu(i,j-1)
               b(i,j)=0.
               c(i,j)=-qu(i,j)
            endif
            if ((qu(i,j-1).lt.0.).and.(qu(i,j).gt.0.)) then
               a(i,j)=0.
               b(i,j)=-qu(i,j)+qu(i,j-1)
               c(i,j)=0.
            endif
		  if ((qu(i,j-1).eq.0.).and.(qu(i,j).gt.0)) then
			 a(i,j)=0.
			 b(i,j)=-qu(i,j)
			 c(i,j)=0.
		  endif
		  

!
! vertical advection
!
! upper layer
!
 10          if (i.eq.1) then
               if (qw(j).gt.0.) then
                  bstar(i,j)=qw(j)
               endif
               if (qw(j).lt.0.) then
                  b(i,j)=b(i,j)+qw(j)
               endif
            endif
!
! lower layer
!
            if (i.eq.2) then
               if (qw(j).lt.0) then
                  bstar(i,j)=-qw(j)
               endif
               if (qw(j).gt.0.) then
                  b(i,j)=b(i,j)-qw(j)
               endif
            endif
!
! longitudinal mixing
!
		  if (j.gt.1) then
			a(i,j)=a(i,j)+Eu(i,j-1)
			b(i,j)=b(i,j)-(Eu(i,j-1)+Eu(i,j))
			c(i,j)=c(i,j)+Eu(i,j)
		  else
			a(i,j)=0.
			b(i,j)=b(i,j)-Eu(i,j)
			c(i,j)=c(i,j)+Eu(i,j)
		  endif

!
! vertical mixing
!
            b(i,j)=b(i,j)-Ew(j)
            bstar(i,j)=bstar(i,j)+Ew(j)
!
! complete equation for point 19.
!
            if (j.eq.19) then
                                !
                                ! longitudinal advection
                                !
               if (qu(i,50).lt.0.) then
                  b(i,19)=b(i,19)+qu(i,50)
               endif
               if (qu(i,50).gt.0.) then
                  d(i,19)=qu(i,50)
               endif 
! d(1,51) occupies column 50 of row 19
! d(2,51) occupies column 50+51 of row 19+51
!
! longitudinal mixing
      
               b(i,19)=b(i,19)-Eu(i,50)
               d(i,19)=d(i,19)+Eu(i,50)
            endif
!
! redo equation for upper layer of point 46 (ocean)
!
! first, longitudinal advection. Ignore (can't define) vertical advection
!
            a(1,46)=0.
            b(1,46)=0.
            c(1,46)=0.
 ! no net advective transport if qu>0
            if (qu(1,46).lt.0.) then
               b(1,46)=qu(1,46)
               c(1,46)=-qu(1,46)
            endif
!
! second, longitudinal mixing
!
            b(1,46)=b(1,46)-Eu(1,46) ! no net mixing to seawards
            c(1,46)=c(1,46)+Eu(1,46)
!
! last, vertical mixing
!
            b(1,46)=b(1,46)-Ew(46)
            bstar(1,46)=Ew(46)
!
! redefine a,b,c,d,bstar
!
		  if (i.eq.1) then
			fac=-real(dt)/(ap(i,j)/depth1(j)*(depth1(j)-delbedh(i,j))
     &			*deltxp(j))
		  endif
		  if (i.eq.2) then
			fac=-real(dt)/(ap(i,j)/(hp(j)-5.)
     &		   *(hp(j)-5.-delbedh(i,j))*deltxp(j))
		  endif
            a(i,j)=fac*a(i,j)
            b(i,j)=1.+fac*b(i,j)
            c(i,j)=fac*c(i,j)
            d(i,j)=fac*d(i,j)
            bstar(i,j)=fac*bstar(i,j)
 300     continue
 350  continue

! boundary conditions at 'p' points 1, 39-45, 46 and 51
!
      do 400 i=1,2
!
! lines for sediment at 45 (delta)
!
		do 410 j=39,45
			a(i,j)=0.
			b(i,j)=1.
			c(i,j)=0.
			bstar(i,j)=0.
 410		continue


!
! put SSC at 51 equal to that at 19
!
         a(i,51)=0.
         b(i,51)=1.
         c(i,51)=0.
         bstar(i,51)=0.
         rhs(51)=0.
         rhs(51+51)=0.
 400  continue

!
! ocean sediment at 46
!
      a(2,46)=0.
      b(2,46)=1.
      c(2,46)=0.
      bstar(2,46)=0.

!
! Mallard Island boundary condition
!
	if (qu(2,38).gt.0) then
		a(1,39)=0.
		b(1,39)=1.
		c(1,39)=0.
		bstar(1,39)=0.
		rhs(39)=0.
	endif

! fill matrix to be inverted
!
      do 550 i=1,102
         do 500 j=1,102
            G(i,j) = 0.0
 500     continue
 550  continue

!upper left
      do 600 k=1,51
         l=k
         G(k,l)=b(1,k)
 600  continue
      do 700 k=2,51
         l=k-1
         G(k,l)=a(1,k)
 700  continue
      do 800 k=1,50
         l=k+1
         G(k,l)=c(1,k)
 800  continue
      G(19,50)=d(1,19)
      G(51,19)=-1.

!upper right
      do 900 k=1,51
         l=k+51
         G(k,l)=bstar(1,k)
 900  continue
	if (qu(2,38).gt.0) then
		G(39,38+51)=-1.*abs(qu(2,38)/qu(1,38))
	endif

!bottom right
	do 1000 k=1+51,51+51
	l=k
	G(k,l)=b(2,k-51)
 1000 continue
      do 1100 k=2+51,51+51
         l=k-1
         G(k,l)=a(2,k-51)
 1100 continue
      do 1200 k=1+51,50+51
         l=k+1
         G(k,l)=c(2,k-51)
 1200 continue
      G(19+51,50+51)=d(2,19)
      G(51+51,19+51)=-1.

!bottom left
      do 1300 k=1+51,51+51
         l=k-51
         G(k,l)=bstar(2,l)
 1300 continue

! invert matrix
!
      call ludcmp(G,indx)
      call lubksb(G,indx,rhs)
      
!
! fill sedp with updated values
!
 
      do 1400 i = 1,51
         sedp(1,i) = rhs(i)
         sedp(2,i) = rhs(i+51)
 1400 continue

!
! Calculate mallard sediment flux back upstream
! if qu is gt 0, flow is upstream and must account for losses
	if ((qu(1,38).lt.0).and.(qu(2,38).gt.0)) then
		malfluxout=qu(2,38)*sedp(2,38)*real(dt)
		ssmalflux=ssmalflux-qu(1,38)*sedp(1,39)*real(dt)/1000000.
	else
		malfluxout=0.
	endif

!
! Calculate the flux at Golden Gate, kg
!
      if ((qu(1,48).gt.0.).and.(qu(2,48).gt.0.)) then
          ggflux=(-sedp(1,48)*qu(1,48)*real(dt)
     &	  -sedp(2,48)*qu(2,48)*real(dt)
     &	  +(sedp(1,49)-sedp(1,48))*Eu(1,48)*real(dt)
     &	  +(sedp(2,49)-sedp(2,48))*Eu(2,48)*real(dt))/1000.
      endif
      if ((qu(1,48).lt.0.).and.(qu(2,48).lt.0.)) then
          ggflux=(-sedp(1,49)*qu(1,48)*real(dt)
     &	  -sedp(2,49)*qu(2,48)*real(dt)
     &	  +(sedp(1,49)-sedp(1,48))*Eu(1,48)*real(dt)
     &	  +(sedp(2,49)-sedp(2,48))*Eu(2,48)*real(dt))/1000.
      endif
      if ((qu(1,48).gt.0.).and.(qu(2,48).lt.0.)) then
          ggflux=(-sedp(1,48)*qu(1,48)*real(dt)
     &	  -sedp(2,49)*qu(2,48)*real(dt)
     &	  +(sedp(1,49)-sedp(1,48))*Eu(1,48)*real(dt)
     &	  +(sedp(2,49)-sedp(2,48))*Eu(2,48)*real(dt))/1000.
      endif
      if ((qu(1,48).lt.0.).and.(qu(2,48).gt.0.)) then
          ggflux=(-sedp(1,49)*qu(1,48)*real(dt)
     &	  -sedp(2,48)*qu(2,48)*real(dt)
     &	  +(sedp(1,49)-sedp(1,48))*Eu(1,48)*real(dt)
     &	  +(sedp(2,49)-sedp(2,48))*Eu(2,48)*real(dt))/1000.
      endif

!
! explicit treatment of erosion deposition: occuring over every timestep
! no erosion/deposition calculations for mallard island and upstream 
! (39-45), and the ocean box (46)
      do 1600 j=1,50
          if ((j.ne.39).and.(j.ne.40).and.(j.ne.41).and.
     &      (j.ne.42).and.(j.ne.43).and.(j.ne.44).and.(j.ne.45).and.
     &	  (j.ne.46)) then
!
		! initialize net mass change in box segments to zero
		  netmass(1,j)=0.
		  netmass(2,j)=0.
		  chgbedh(1,j)=0.
		  chgbedh(2,j)=0.
!
		! set memory of previously deposited sediment from last time step
		  stay(1)=mass_sed1(1,j)
		  stay(2)=mass_sed1(2,j)
!
!
	! calculate upper layer deposition to the shoals and lower layer
		  fac2(1)=constd*sedp(1,j)*real(dt)*aztool(j)
	! calculate lower layer deposition to the channel
		  fac2(2)=constd*sedp(2,j)*real(dt)*aw(2,j)
!
! discretize the time step so that no more than 25% of sediment in
! suspension is deposited at one time. largest number of necessary
! time steps is taken as the time descretization
  		  n(1)=4.*fac2(1)/(sedp(1,j)*ap(1,j)
     &		 /depth1(j)*(depth1(j)-delbedh(1,j))*deltxp(j))
		  n(2)=4.*fac2(2)/(sedp(2,j)*ap(2,j)
     &		 /(hp(j)-5.)*(hp(j)-5.-delbedh(2,j))*deltxp(j))
		! top layer controls timestep distrectization
		  if (n(1).gt.n(2)) then
			deltime=n(1)
		! lower layer controls timestep distrectization		  
		  else
			deltime=n(2)
		  endif
!
! Step through the discretized time step, first lower then upper layers
! for each layer, first deposition, then erosion
		  do 1650 i=1,(int(deltime)+1)
!
		! recalculate deposition rates.  Call dep_conserve to check
		! mass conservation
			fac2u=constd*sedp(1,j)*real(dt)/(real(int(deltime))+1.)
     &		  *(aztool(j)-aw(2,j))
			fac2l=constd*sedp(1,j)*real(dt)
     &		  /(real(int(deltime))+1.)*aw(2,j)
			fac2(1)=fac2u+fac2l
			fac2(2)=constd*sedp(2,j)*real(dt)
     &		  /(real(int(deltime))+1.)*aw(2,j)

!			
		 ! make sure more mass isn't deposited than is in suspension
			call dep_conserve(fac2(1),fac2(2),sedp(1,j),sedp(2,j),
     &				ap(1,j),ap(2,j),deltxp(j),j,delbedh(1,j),
     &				delbedh(2,j),hp(j),chgbedh(1,j),chgbedh(2,j),
     &				aztool(j))
!
		! calculate upper layer shear from 1: currents and 2: wind
		! wind data are from SFO airport or the USGS Suisun met station
			if (j.eq.1) then
			tau1=1000.*9.81*(shale(j)*depth1(j)
     &			/(depth1(j)-delbedh(1,j))*utideu(j))**2.
     &			/((depth1(j)-delbedh(1,j))**(1./6.)/0.02)**2.
			else
  			tau1=1000.*9.81*(shale(j)*depth1(j)
     &			/(depth1(j)-delbedh(1,j))*0.5
     &			*(utideu(j)+utideu(j-1)))**2.
     &			/((depth1(j)-delbedh(1,j))**(1./6.)/0.02)**2.
			endif
!
			if (j.lt.20) then
				tau2=constw*1000.*0.1*sfo2win
     &				/(cosh(0.2829*(depth1(j)-delbedh(1,j))))**2
			else
				tau2=constw*1000.*0.1*sui2win
     &				/(cosh(0.2829*(depth1(j)-delbedh(1,j))))**2
			endif
			taub(1)=tau1+tau2

		! calculate lower layer shear from currents only
			if (j.eq.1) then
			taub(2)=1000.*9.81*(chane(j)*(hp(j)-5.)
     &			/(hp(j)-5.-delbedh(2,j))*utideu(j))**2.
     &			/((hp(j)-5.-delbedh(2,j))**(1./6.)/0.02)**2.
			else
			taub(2)=1000.*9.81*(chane(j)*(hp(j)-5.)
     &			/(hp(j)-5.-delbedh(2,j))
     &			*0.5*(utideu(j)+utideu(j-1)))**2.
     &			/((hp(j)-5.-delbedh(2,j))**(1./6.)/0.02)**2.
			endif
!
!

		! calculate erosion rates
			fac1(1)=conste(j)*100.*taub(1)*real(dt)
     &	      /(real(int(deltime))+1.)*(aztool(j)-aw(2,j))
			fac1(2)=conste(j)*100.*taub(2)*real(dt)
     &	      /(real(int(deltime))+1.)*aw(2,j)
! 
! lower layer....
		! eroded mass is less than layer one sediment mass
			if (mass_sed1(2,j).ge.fac1(2)) then
			! change of mass in suspension (+ increase, - decrease)
			  mass_chg=fac1(2)-fac2(2)
			! change of bed height during
			  chgbedh(2,j)=chgbedh(2,j)-mass_chg/(beddens(j)*aw(2,j))
			  if ((hp(j)-5.-chgbedh(2,j)).lt.0) then
				pause 'lower layer deposition exceeds volume'
			  endif
			! remove eroded mass from previous time step deposited mass
			  stay(2)=stay(2)-fac1(2)
			! keep track of sediment mass in layer 1
		      mass_sed1(2,j)=mass_sed1(2,j)-mass_chg
			! keep track of net mass change on bed during time step
			  netmass(2,j)=netmass(2,j)-mass_chg
			!calculate new and old volumes for mass conservation
			  Call volume(2,delbedh(2,j),chgbedh(2,j),ap(2,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update SSC in lower layer			
		      sedp(2,j)=(sedp(2,j)*old_vol+mass_chg)/new_vol
!
		! eroded mass is greater than layer one sediment mass
		! excess mass is eroded from layer two sediment (compacted)
			elseif (mass_sed1(2,j).lt.fac1(2)) then
			! mass eroded from layer 2, to be multiplied by erosion factor
			  fac3=fac1(2)-mass_sed1(2,j)
			! mass eroded from layer 1 equals layer one mass
			  fac1(2)=mass_sed1(2,j)
			! efac is the erodilibity factor which is multiplied by fac3
			  efac=exp(35.*bed_diff2(2,j))
			  if (efac.lt.0.25) then
			    efac=0.25
			  endif
			! change of mass in suspension (+ increase, - decrease)
			  mass_chg=fac1(2)+efac*fac3-fac2(2)
			! update eroded depth into layer 2
			  bed_diff2(2,j)=bed_diff2(2,j)
     &		    -fac3*efac/(beddens(j)*aw(2,j))
			! change of bed height during current time step
			  chgbedh(2,j)=chgbedh(2,j)-mass_chg/(beddens(j)*aw(2,j))
			  if ((hp(j)-5.-chgbedh(2,j)).lt.0) then
				pause 'lower layer deposition exceeds volume'
			  endif
			! keep track of sediment mass in layer 1
			  mass_sed1(2,j)=fac2(2)
			! remove eroded mass from previous time step deposited mass
			  stay(2)=stay(2)-fac1(2)
			! keep track of net mass change during the time step
			  netmass(2,j)=netmass(2,j)-mass_chg
			! calculate new and old volumes for mass conservation
			  Call volume(2,delbedh(2,j),chgbedh(2,j),ap(2,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update SSC in lower layer
		      sedp(2,j)=(sedp(2,j)*old_vol+mass_chg)/new_vol
		    endif
!
! upper layer.....
		! no shoals present in upper layer, deposition to lower layer only
			if (aztool(j).eq.aw(2,j)) then
			  fac2(1)=constd*sedp(1,j)*real(dt)
     &			/(real(int(deltime))+1.)*aztool(j)
			  sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)-fac2(1))
     &	        /(ap(1,j)*deltxp(j))
		! calculate new and old volumes for mass conservation
			  Call volume(2,delbedh(2,j),chgbedh(2,j),ap(2,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			  sedp(2,j)=(sedp(2,j)*new_vol+fac2(1))/new_vol
		
		! eroded mass is greater than layer one sediment mass
		! excess mass is eroded from layer two sediment (compacted)
			elseif (mass_sed1(1,j).lt.fac1(1)) then
		! mass eroded from layer 2, to be multiplied by erosion factor
			  fac3=fac1(1)-mass_sed1(1,j)
			! mass eroded from layer 1 equals layer one mass
			  fac1(1)=mass_sed1(1,j)
			! efac is the erodilibity factor which is multiplied by fac3
			  efac=exp(35.*bed_diff2(1,j))
			  if (efac.lt.0.25) then
			    efac=0.25
			  endif
			! change of mass in suspension (+ increase, - decrease)
			  mass_chg=fac1(1)+efac*fac3-fac2(1)
			! update eroded depth into layer 2
			  bed_diff2(1,j)=bed_diff2(1,j)
     &		    -fac3*efac/(beddens(j)*(aztool(j)-aw(2,j)))
			! change of bed height during current time step
			  chgbedh(1,j)=chgbedh(1,j)-(mass_chg+fac2l)
     &		    /(beddens(j)*(aztool(j)-aw(2,j)))
			! mass in layer 1 equals newly deposited sediment
			  mass_sed1(1,j)=fac2u
			! remove eroded mass from previous time step deposited mass
			  stay(1)=stay(1)-fac1(1)
			! keep track of net mass change during the time step
			  netmass(1,j)=netmass(1,j)-(mass_chg+fac2l)
			! calculate new and old volumes for mass conservation
			  Call volume(1,delbedh(1,j),chgbedh(1,j),ap(1,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update upper layer SSC
		      sedp(1,j)=(sedp(1,j)*old_vol+mass_chg)/new_vol
			! calculate new and old volumes for mass conservation
			  Call volume(2,delbedh(2,j),chgbedh(2,j),ap(2,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update lower layer SSC
			  sedp(2,j)=(sedp(2,j)*new_vol+fac2l)/new_vol

		! eroded mass is less than layer one sediment mass
		    elseif (mass_sed1(1,j).ge.fac1(1)) then

			! change of mass in suspension (+ increase, - decrease)
			  mass_chg=fac1(1)-fac2(1)
			! change of bed height during current time step
			  chgbedh(1,j)=chgbedh(1,j)-(mass_chg+fac2l)
     &		    /(beddens(j)*(aztool(j)-aw(2,j)))
			! remove eroded mass from previous time step deposited mass
			  stay(1)=stay(1)-fac1(1)
			! keep track of sediment mass in layer 1
			  mass_sed1(1,j)=mass_sed1(1,j)-(mass_chg+fac2l)
			! keep track of net mass change on the bed during the time step
			  netmass(1,j)=netmass(1,j)-(mass_chg+fac2l)
			! calculate new and old volumes for mass conservation
			  Call volume(1,delbedh(1,j),chgbedh(1,j),ap(1,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update upper layer SSC
		      sedp(1,j)=(sedp(1,j)*old_vol+mass_chg)/new_vol
			! calculate new and old volumes for mass conservation
			  Call volume(2,delbedh(2,j),chgbedh(2,j),ap(2,j),deltxp(j),
     &			   hp(j),new_vol,old_vol,aztool(j))
			! update lower layer SSC
			  sedp(2,j)=(sedp(2,j)*new_vol+fac2l)/new_vol
		    endif

		! set upper and lower SSC equal by assuming well-mixed box
		! an assumption because lower box is only 0.5 m deep.
		    if ((j.eq.1).or.(j.eq.2).or.(j.eq.3)) then
			  sedp(1,j)=(sedp(1,j)*ap(1,j)*deltxp(j)
     &			/depth1(j)*(depth1(j)-delbedh(1,j)-chgbedh(1,j))
     &	        +sedp(2,j)*ap(2,j)*deltxp(j)/(hp(j)-5.)
     &		    *(hp(j)-5.-delbedh(2,j)-chgbedh(2,j)))
     &		    /(ap(1,j)/depth1(j)
     &			*(depth1(j)-delbedh(1,j)-chgbedh(1,j))*deltxp(j)
     &			+ap(2,j)/(hp(j)-5.)
     &			*(hp(j)-5.-delbedh(2,j)-chgbedh(2,j))*deltxp(j))
			sedp(2,j)=sedp(1,j)
		endif

! update the net long-term change in bed elevation
! upper layer
		delbedh(1,j)=delbedh(1,j)+chgbedh(1,j)
		chgbedh(1,j)=0.
		if (delbedh(1,j).gt.depth1(j)) then
			write(*,12) 1, j, (depth1(j)-delbedh(1,j))
 12			format ('i = ', I2, 1X, 'j = ', I2, 1X, 'h= ', f5.3)
			pause 'deposited more sediment than depth allows'
		endif
! lower layer
		delbedh(2,j)=delbedh(2,j)+chgbedh(2,j)
		chgbedh(2,j)=0.
		if (delbedh(2,j).gt.(hp(j)-5.)) then
			write(*,13) 2, j, (hp(j)-5.-delbedh(2,j))
 13			format ('i = ', I2, 1X, 'j = ', I2, 1X, 'h= ', f5.3)
			pause 'deposited more sediment than depth allows'
		endif

 1650		  continue

	! at end of segment's time steping, add any remaining layer one 
	! sediment from the previous time step into layer two.
		! lower layer
		  if (stay(2).gt.0.) then
			bed_diff2(2,j)=bed_diff2(2,j)
     &	      +stay(2)/(beddens(j)*aw(2,j))
			if (bed_diff2(2,j).gt.0.)then
			  bed_diff2(2,j)=0.
		    endif
			mass_sed1(2,j)=mass_sed1(2,j)-stay(2)
		  endif
		! upper layer
		  if ((stay(1).gt.0.).and.(aztool(j).gt.aw(2,j))) then
		  bed_diff2(1,j)=bed_diff2(1,j)
     &		+stay(1)/(beddens(j)*(aztool(j)-aw(2,j)))
			if (bed_diff2(1,j).gt.0.)then
			  bed_diff2(1,j)=0.
			endif
		    mass_sed1(1,j)=mass_sed1(1,j)-stay(1)
		  endif
!
		endif
 1600 continue

! set variables of box 51 equal to those of box 19
      sedp(1,51)=sedp(1,19)
      sedp(2,51)=sedp(2,19)
	netmass(1,51)=netmass(1,19)
	netmass(2,51)=netmass(2,19)
	delbedh(1,51)=delbedh(1,19)
	delbedh(2,51)=delbedh(2,19)

!
! remove mass from wetland sinks
! mass is distributed equally between basin segments
!
	do 155 i=34,38
		sedp(1,i)=(sedp(1,i)*ap(1,i)/depth1(i)*(depth1(i)-delbedh(1,i))
     &	  *deltxp(i)-suwetsink/5)/(ap(1,i)/depth1(i)
     &	  *(depth1(i)-delbedh(1,i))*deltxp(i))
 155	continue
	do 160 i=23,28
		sedp(1,i)=(sedp(1,i)*ap(1,i)/depth1(i)*(depth1(i)-delbedh(1,i))
     &	  *deltxp(i)-spwetsink/6)/(ap(1,i)/depth1(i)
     &	  *(depth1(i)-delbedh(1,i))*deltxp(i))
 160	continue
	do 170 i=16,22
		sedp(1,i)=(sedp(1,i)*ap(1,i)/depth1(i)*(depth1(i)-delbedh(1,i))
     &	  *deltxp(i)-cbwetsink/7)/(ap(1,i)/depth1(i)
     &	  *(depth1(i)-delbedh(1,i))*deltxp(i))
 170	continue
	do 180 i=2,14
		sedp(1,i)=(sedp(1,i)*ap(1,i)/depth1(i)*(depth1(i)-delbedh(1,i))
     &	  *deltxp(i)-sswetsink/13)/(ap(1,i)/depth1(i)
     &	  *(depth1(i)-delbedh(1,i))*deltxp(i))
 180	continue


	!baywide wetland mass loss, in metric tons
	wetloss=(suwetsink+spwetsink+cbwetsink+sswetsink)/1000000.

! calculate the bay-wide mass change, in metric tons
	baysed=0.
	do 1751 j=1,38
		baysed=baysed+netmass(1,j)+netmass(2,j)
 1751	continue
		baysed=(baysed+netmass(1,49)+netmass(2,49)
     &		+netmass(1,50)+netmass(2,50))/1000./1000.

! calculate the total volume in suspension baywide in metric tons
	suspenmass=0.
	do 1900 j=1,38
		suspenmass=suspenmass+sedp(1,j)*ap(1,j)/depth1(j)
     &		*(depth1(j)-delbedh(1,j))*deltxp(j)+sedp(2,j)*ap(2,j)
     &		/(hp(j)-5.)*(hp(j)-5.-delbedh(2,j))*deltxp(j)
 1900	continue
		suspenmass=suspenmass+sedp(1,49)*ap(1,49)/depth1(49)
     &		*(depth1(49)-delbedh(1,49))*deltxp(49)+sedp(2,49)*ap(2,49)
     &		/(hp(49)-5.)*(hp(49)-5.-delbedh(2,49))*deltxp(49)
     &		+sedp(1,50)*ap(1,50)/depth1(50)*(depth1(50)-delbedh(1,50))
     &		*deltxp(50)+sedp(2,50)*ap(2,50)/(hp(50)-5.)
     &		*(hp(50)-5.-delbedh(2,50))*deltxp(50)
		suspenmass=suspenmass/1000./1000.

! calculate mean SSC in Suisun Bay
	suissc(1)=0
	vol1=0
	suissc(2)=0
	vol2=0
	do 4000 j=29,39
! upper
		new_vol=ap(1,j)/5.*(5.-delbedh(1,j))*deltxp(j)
		suissc(1)=(sedp(1,j)*new_vol+suissc(1)*vol1)
     &		/(new_vol+vol1)
		vol1=vol1+new_vol
! lower
		new_vol=ap(2,j)/(hp(j)-5.)*(hp(j)-5.-delbedh(2,50))*deltxp(j)
		suissc(2)=(sedp(2,j)*new_vol+suissc(2)*vol2)
     &		/(new_vol+vol2)
		vol2=vol2+new_vol
 4000	continue				

! calculate mean SSC in San Pablo Bay
	spbssc(1)=0
	vol1=0
	spbssc(2)=0
	vol2=0
	do 4001 j=23,28
! upper
		new_vol=ap(1,j)/5.*(5.-delbedh(1,j))*deltxp(j)
		spbssc(1)=(sedp(1,j)*new_vol+spbssc(1)*vol1)
     &		/(new_vol+vol1)
		vol1=vol1+new_vol
! lower
		new_vol=ap(2,j)/(hp(j)-5.)*(hp(j)-5.-delbedh(2,50))*deltxp(j)
		spbssc(2)=(sedp(2,j)*new_vol+spbssc(2)*vol2)
     &		/(new_vol+vol2)
		vol2=vol2+new_vol
 4001	continue
 
! calculate mean SSC in Central Bay
	cbssc(1)=0
	vol1=0
	cbssc(2)=0
	vol2=0
	do 4002 j=15,22
! upper
		new_vol=ap(1,j)/5.*(5.-delbedh(1,j))*deltxp(j)
		cbssc(1)=(sedp(1,j)*new_vol+cbssc(1)*vol1)
     &		/(new_vol+vol1)
		vol1=vol1+new_vol
! lower
		new_vol=ap(2,j)/(hp(j)-5.)*(hp(j)-5.-delbedh(2,50))*deltxp(j)
		cbssc(2)=(sedp(2,j)*new_vol+cbssc(2)*vol2)
     &		/(new_vol+vol2)
		vol2=vol2+new_vol
 4002	continue
 	do 4004 j=46,50
! upper
		new_vol=ap(1,j)/5.*(5.-delbedh(1,j))*deltxp(j)
		cbssc(1)=(sedp(1,j)*new_vol+cbssc(1)*vol1)
     &		/(new_vol+vol1)
		vol1=vol1+new_vol
! lower
		new_vol=ap(2,j)/(hp(j)-5.)*(hp(j)-5.-delbedh(2,50))*deltxp(j)
		cbssc(2)=(sedp(2,j)*new_vol+cbssc(2)*vol2)
     &		/(new_vol+vol2)
		vol2=vol2+new_vol
 4004	continue
 
! calculate mean SSC in South Bay
	sbssc(1)=0
	vol1=0
	sbssc(2)=0
	vol2=0
	do 4003 j=1,14
! upper
		new_vol=ap(1,j)/5.*(5.-delbedh(1,j))*deltxp(j)
		sbssc(1)=(sedp(1,j)*new_vol+sbssc(1)*vol1)
     &		/(new_vol+vol1)
		vol1=vol1+new_vol
! lower
		new_vol=ap(2,j)/(hp(j)-5.)*(hp(j)-5.-delbedh(2,50))*deltxp(j)
		sbssc(2)=(sedp(2,j)*new_vol+sbssc(2)*vol2)
     &		/(new_vol+vol2)
		vol2=vol2+new_vol
 4003	continue

      return
      end

! Checks that mass is conserved: more sediment cannot be deposited
! than is in suspension
		subroutine dep_conserve(fac2_up,fac2_low,sedp_up,sedp_low,
     &					ap_up,ap_low,deltxp,j,delbedh1,delbedh2,hp,
     &					chgbedh1,chgbedh2,aztool)

	real*8  fac2_up,fac2_low,sedp_up,sedp_low,n1,n2
	real*8	ap_up,ap_low,deltxp,delbedh1,delbedh2,hp
	real*8	chgbedh1,chgbedh2,aztool,depth1
	integer i, j
	
	depth1=ap_up*deltxp/aztool
	n1=fac2_up/(sedp_up*ap_up/depth1*(depth1-delbedh1-chgbedh1)*deltxp)
	n2=fac2_low/(sedp_low*ap_low/(hp-5.)
     &	*(hp-5.-delbedh2-chgbedh2)*deltxp)
	if (n1.gt.1.) then
		write(*,100) 1, j, n1
 100		format ('i = ', I2, 1X, 'j = ', I2, 1X, 'dep = ', f4.2)
		pause 'error in sediment mass conservation'
		fac2_up=fac2_up/n1
	endif
	if (n2.gt.1.) then
		write(*,200) 2, j, n2
 200		format ('i = ', I2, 1X, 'j = ', I2, 1X, 'dep = ', f4.2)
		pause 'error in sediment mass conservation'
		fac2_low=fac2_low/n2
	endif


	return
	end

! Calculates new and old volumes for mass conservation
! than is in suspension
		subroutine volume(i,delbedh,chgbedh,ap,deltxp,hp,new_vol
     &					,old_vol,aztool)

	real*8  delbedh,chgbedh,ap,deltxp,hp,new_vol,old_vol,depth,aztool
	integer i

	if (i.eq.1) then
		depth=ap*deltxp/aztool
		old_vol=ap*deltxp/depth*(depth-delbedh)
		new_vol=ap*deltxp/depth*(depth-delbedh-chgbedh)
	endif
	if (i.eq.2) then
		old_vol=ap*deltxp/(hp-5.)*(hp-5.-delbedh)
		new_vol=ap*deltxp/(hp-5.)*(hp-5.-delbedh-chgbedh)
	endif


	return
	end

! Matrix Inversion Routines (L-U decomposition method) from Numerical Recipes,
! Press et al, section 2.3

      subroutine ludcmp(A,indx)

      integer indx(102), imax
      real*8 A(102,102), vv(102),d, tiny, aamax, sum, dum
      parameter (tiny = 1.0e-20)
      
      d=1.
      do 120 i=1,102
         aamax=0.
         do 110 j=1,102
            if (abs(A(i,j)).gt.aamax) aamax=abs(A(i,j))
 110     continue
         if (aamax.eq.0.) pause 'Singular matrix.'
         vv(i) = 1./aamax
 120  continue

      do 190 j=1,102
         if (j.gt.1) then
            do 140 i=1,j-1
               sum=A(i,j)
               if (i.gt.1) then
                  do 130 k=1,i-1
                     sum = sum-A(i,k)*A(k,j)
 130              continue
                  A(i,j) = sum
               endif
 140        continue
         endif

         aamax=0.

         do 160 i=j,102
            sum=A(i,j)
            if (j.gt.1) then
               do 150 k=1,j-1
                  sum = sum - A(i,k)*A(k,j)
 150           continue
               A(i,j) = sum
            endif
            dum = vv(i)*abs(sum)
            if (dum.ge.aamax) then
               imax=i
               aamax=dum
            endif
 160     continue

         if (j.ne.imax) then
            do 170 k=1,102
               dum = A(imax,k)
               A(imax,k) = A(j,k)
               A(j,k) = dum
 170        continue

            d=-d
            vv(imax) = vv(j)
         endif
         indx(j) = imax
         if (j.ne.102) then
            if (A(j,j).eq.0.) A(j,j)=tiny
            dum = 1./A(j,j)
            do 180 i=j+1,102
               A(i,j) = A(i,j)*dum
 180        continue
         endif
 190  continue
      if (A(102,102).eq.0.) A(102,102)=tiny


      return
      end




      subroutine lubksb(A,indx,b)

      integer indx(102), ii, L
      real*8 A(102,102), b(102), sum

      ii=0
      do 120 i=1,102
         L=indx(i)
         sum=b(L)
         b(L)=b(i)
         if (ii.ne.0) then
              do 110 j=ii,i-1
               sum=sum-A(i,j)*b(j)
 110        continue
         elseif (sum.ne.0.) then
            ii=i
         endif
         b(i) = sum
 120  continue

      do 140 i=102,1,-1
         sum=b(i)
         if (i.lt.102) then
            do 130 j=i+1,102
               sum=sum-A(i,j)*b(j)
 130        continue
         endif
         b(i) = sum/A(i,i)
 140  continue

      return
      end





      subroutine tide_var(y2,y2_tab,
     &                          x_tab,x)

      
      real*8 y2(51)
      real*8 y2_tab(51,5)
      real*8  x_tab(5), x

      real*8 x00, x05, x10, x15, x30, dx 
!
! usage: [elevation,speed,dissipation,stress]=tide_var(e2_table,u2_table,...
!        diss_table,str_table,[1:51],rel_table,x);
!
! computes daily averaged tidal variables. Elevation is half the daily 
! averaged tidal range; speed is the daily averaged, maximum semidiurnal
! current speed, dissipation the average rate of dissipation of tidal energy
! and stress is the tidal and daily averaged bed shear stress
!       e2_, u2_, diss_ and str_table are (51,5) matrices holding semidiurnal
! amplitudes (cm), maximum semidiurnal current speeds (cm/s), tidally averaged
! energy dissipation (divide by 100 to get W/m2) and bed shear stress (divide
! by 100 to get N/m2) for 5 tidal ranges at Golden Gate relative to the 
! average tidal range, these relative values are held in rel_table and the
! relative range on the day is x. Linear interpolation is used.
!
! see also: model, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av
!

! use shorter names for the relative-to-average tidal range
!
      x00=x_tab(1)
      x05=x_tab(2)
      x10=x_tab(3)
      x15=x_tab(4)
      x30=x_tab(5)
!
! interpolate for average relative tidal range of the day
!
! check for intermediate neap tides
!
      dx=x10-x05
      if ((x.le.x10).and.(x.gt.x05)) then
         do 100 i=1,51
            y2(i)=y2_tab(i,2)*(x10-x)/dx+y2_tab(i,3)*(x-x05)/dx 
 100     continue
      endif
!
! check for intermediate spring tides
!
      dx=x15-x10 
      if ((x.gt.x10).and.(x.lt.x15)) then
         do 200 i=1,51
            y2(i)=y2_tab(i,3)*(x15-x)/dx+y2_tab(i,4)*(x-x10)/dx 
 200     continue
      endif
!
! check for very high spring tides
!
      dx=x30-x15 
      if (x.ge.x15) then
         do 300 i=1,51
            y2(i)=y2_tab(i,4)*(x30-x)/dx+y2_tab(i,5)*(x-x15)/dx 
 300     continue
      endif
!
! check for very low neap tides
!
      dx=x05-x00 
      if (x.le.x05) then
         do 400 i=1,51
            y2(i)=y2_tab(i,1)*(x05-x)/dx+y2_tab(i,2)*(x-x00)/dx 
 400     continue
      endif


      return
      end




      subroutine tide_av(utideu,speedu,uu,au)

      real*8 utideu(51), uu(2,51), au(2,51)
      real*8 speedu(51), res_speed(51), f1, eps
      parameter (eps = 2.e-16)
!
! usage: [utideu,dissipatu,stressu]=tide_av(speedu,dissipatu,stressu,uu,au)
!
! where: utideu(1,51) is the mean current speed (ie: averaged over depth,
! over a tidal period and, in this model, over a day); dissipatu is the mean 
! energy dissipation, which is corrected here for the effects of near-bed
! residual currents; stressu is the bed shear-stress, which is also corrected
! here for near-bed residual currents; au is area; speedu is the maximum 
! semidiurnal tidal current speed; uu is the residual current computed
! by the model. Usually uu is very small compared with the tidal speed.
! However, in the Delta the residual currents become comparable with the 
! tidal currents. Note that all the corrections for residual current 
! effects are based on <|f|^n> with f=[cos(wt)+uu/speedu] and n = 1, 2 or 3
! for average current, stress and dissipation, respectively.
!
! see also: salmodel, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av
!

!
! scan the lattice
!
      do 100 j=1,51
!
! compute the cross-sectionally averaged residual current speed
!
         res_speed(j)=(au(1,j)*uu(1,j)+au(2,j)*uu(2,j))/
     &                     (au(1,j)+au(2,j)+eps)

!
! ratio of residual current speed to amplitude of tidal current speed
!
         x=abs(res_speed(j)/(speedu(j)+eps))
!
! compute mean current speed
!
         f1=x
         if (x.lt.1.) then
            f1=0.6355+0.0302*x+0.1985*x*x+0.1342*x*x*x
         endif
         utideu(j)=speedu(j)*f1
!
! mean bed shear stress. First compute ratio of bottom layer current speed
! to tidal current speed amplitude, x:
!
!         x=abs(uu(2,j)/(speedu(j)+eps))
!         f2=0.5+x*x
!         stressu(j)=stressu(j)*f2/0.5
!
! mean energy dissipation due to tides and residual currents.
!
!         f3=1.5*x+x*x*x
!        if (x.lt.1.) then
!            f3=0.4231+0.0456*x+1.6876*x*x+0.3424*x*x*x
!         endif
!         dissipatu(j)=dissipatu(j)*f3/0.4231
 100  continue
! end function tide_av

      return
      end




      subroutine mix_coef(Eu,Ew,Nu,hu,deltxu,deltzw,au,aw,
     &                    utideu,uu,denp,calib_Eu,calib_Ew)

      real*8 Eu(2,51), Ew(51), Nu(51), hu(51), deltxu(51), deltzw(51),
     &       au(2,51), aw(2,51), utideu(51), uu(2,51), denp(2,51),
     &       calib_Eu(2,51), calib_Ew(51)
      real*8 g, denf, eps, du(51), ri(51), shear, dw(51)
      parameter (eps=2.e-16)
!
! usage: [Eu,Ew,Nu]=mix_coef(hu,deltxu,deltzw,au,aw,utideu,denp,...
!				calib_Eu,calib_Ew):
!
! where: Eu and Ew are the longitudinal and vertical volume mixing 
! rates (m3/s); utideu the mean tidal current speed (m/s, >0); denp the
! water density (kg/m3); calib_Eu a calibibration coefficient for the 
! longitudinal mixing, which is 1 for all segments with no calibration
! and calib_Ew; which has the same meaning as calib_Eu but for the vertical
! mixing
!
! see also: salmodel, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av
  
!
! gravitational acceleration and typical water density
!
      g=9.81
      denf=1000.
!
! scan the grid
!
      do 200 i=1,2
         do 100 j=1,51
! 
! longitudinal dispersion coefficients: first compute coefficient
! du (m2/s) then mixing volume rate, Eu (m3/s).
!
! first term is due to tidal trapping and transverse shear in tidal
! currents (Fischer et al, p. 234 and 241) with assumed cross-estuary
! mixing time equal to a tidal period. Other terms due to
! transverse density flows and wind could be added and an arbitrary
! 10 m2/s is added to take these into account when tidal currents
! become very small (eg: southern-most SB)
!
            du(j)=1000.*utideu(j)*utideu(j)+10.
            Eu(i,j)=calib_Eu(i,j)*au(i,j)*du(j)/deltxu(j)

!
! vertical dispersion coefficients: first compute estimate of vertical shear,
! then gradient Richardson Number, ri, and then dispersion coefficient, dw,
! followed by mixing volume rate, Ew
!
            shear=utideu(j)/(hu(j)+eps)+abs(uu(1,j)-uu(2,j))/deltzw(j)
            ri(j)=g*((denp(2,j)-denp(1,j))/deltzw(j))/
     &                     (denf*shear*shear+eps)
!
! Restrict Ri effects to Ri<2 and use Uncles and Joint(1982) and
! Walters, Cheng and Conomos(1985) for the depth-averaged, tidally 
! averaged vertical mixing coefficients in homogeneous conditions.
!
            if  (ri(j).le.0.) then
               ri(j)=0.
            endif
            if  (ri(j).ge.2.) then
               ri(j)=2.
            endif
!
! compute eddy diffusivity and viscosity
!
            dw(j)=(2.3e-3*hu(j)*hu(j)*shear*(1+3.33*ri(j))**(-1.5))
            Nu(j)=(2.3e-3*hu(j)*hu(j)*shear*(1+10.0*ri(j))**(-0.5))
!
! bottom layer of point 2 (southern-most SB) is only 0.5m thick - 'tie'
! to upper layer by forcing large vertical mixing
!
            dw(2)=1.
            Nu(2)=1.
!
! compute vertical mixing coefficient
!
            Ew(j)=calib_Ew(j)*aw(2,j)*dw(j)/deltzw(j)

 100     continue
 200  continue

!	Eu(1,1)=0.	!Added for no flux between 1 and 2
!	Eu(2,1)=0.	!Also added, as above
!	Ew(1)=0.	
!
! end function mix_coef
      return
      end





      subroutine flows(qau,qu,qw,uu,qrivp,qprecipp,qevapp,au,aw,deltxu,
     &                  deltxp,hu,denp,widthav,Nu,utideu)

      real*8 qau(51), qu(2,51), qw(51), uu(2,51), qrivp(2,51), 
     &       qprecipp(51), qevapp(51), au(2,51), aw(2,51), deltxu(51), 
     &       deltxp(51), hu(51), denp(2,51), widthav(2,51), 
     &       Nu(51)
      real*8 dum, dengradu(2,51), g, denf, htu, utideu(51)
      real*8 k, h, phi, n, y, r, l, u, t, v, w, x, A1, B1, A21, A22
      real*8 B21, B22, AL1, AL2, DE1, DE2, top, bot, i, a, d, p, q
!
! usage: [qau,qu,qw,uu]=flows(qrivp,qprecipp,qevapp,au,aw,deltxu,deltxp,hu,hp,denp,widthav,Nu);
!
! computes the flows through the section areas between segments of the model
! estuary given river inputs to the top and bottom layers (qrivp(1,:),
! qrivp(2,:), respectively, in m3/s), evaporation and precipitation 
! (qevapp(:) and qprecipp(:) in m/s), section areas for both layers, 
! au (m2) and interface areas, aw (m2/s). The vertical profile of 
! longitudinal current is estimated using Officer's (1976) equation for the 
! gravitational circulation, which requires the water density (denp, kg/m3),
! depth, hu (m) and the vertical eddy viscosity, Nu (m2/s).
!
! see also: salmodel, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av

!
! compute total flow (m3/s) through section faces (South Bay)
!
      do 50 i=1,51
         qau(i) = 0.
 50   continue
      qau(1)=(qrivp(1,1)+qrivp(2,1))+(qprecipp(1)-qevapp(1))*aw(1,1)
      do 100 j=2,18
         qau(j)=qau(j-1)+(qrivp(1,j)+qrivp(2,j))+
     &                     (qprecipp(j)-qevapp(j))*aw(1,j)
 100  continue
!
! compute total flow (m3/s) through section faces (North Bay)
!

      do 200 j=44,19,-1
         qau(j)=qau(j+1)-(qrivp(1,j+1)+qrivp(2,j+1))-
     &           (qprecipp(j+1)-qevapp(j+1))*aw(1,j+1)
 200  continue
!
! compute total flow (m3/s) through section face (Angel Island)
!
      qau(50) = qau(19)-qau(18)-(qrivp(1,19)+qrivp(2,19))-
     &          (qprecipp(19)-qevapp(19))*aw(1,19)
!
! compute total flow (m3/s) through section faces (Ocean limb)
!

      do 300 j=49,46,-1
         qau(j)=qau(j+1)-(qrivp(1,j+1)+qrivp(2,j+1))-
     &           (qprecipp(j+1)-qevapp(j+1))*aw(1,j+1)
 300  continue
!
! check this
!
      dum=0.
      do 400 j=1,50
         if (j.ne.46) then
            dum=dum+qrivp(1,j)+qrivp(2,j)-aw(1,j)*
     &                (qevapp(j)-qprecipp(j))
         endif
 400  continue
      if (abs(qau(46)+dum).gt.1.0e-6*abs(qau(46))) then
         pause 'error in flow-conservation check within flows.f'
      endif
!
! compute currents in the upper and lower layers using Officer's (1976)
! equations. First compute longitudinal density gradient
!
      call  den_grad(dengradu,deltxu,deltxp,denp)
!
! compute slope of estuary surface, velocities and flows based on 
! Officer's equations approximating gravitational circulation but
! with different longitudinal density gradients in the surface
! and bottom layers and with the total shear force on the upper
! layer transferred to the lower layer. In these solutions the 
! widths in the upper and lower layers are taken to be constant
! through each layer and:
!
! (density*eddy viscosity *width*length*vertical shear)
!
! is the same at the layer interface, approaching from either side
!
      g=9.81
      denf=1000.0
      uu(1,51)=0.
      uu(2,51)=0.
      qu(1,51)=0.
      qu(2,51)=0.
!
!
! thickness of surface layer
!
      htu=5.

      do 500 j=1,50

         k=htu
         h=hu(j)
         phi=utideu(j)*5.0e-3
         n=Nu(j)
         y=widthav(1,j)/widthav(2,j)
         r=denf
         l=dengradu(2,j)
         u=dengradu(1,j)
         t=k*g*(u-l)
         v=au(1,j)
         w=au(2,j)
         x=qau(j)


         A1=  1. + (h-k)*phi/n
         B1=(1.-y)

         A21= g*(l*(h-k)**2*(2.*h+k) - u*k**3+3.*t*(h-k)**2/g)/(6.*r*n)

         A22=-g*h*(h-2.*k)/(2.*n)

         B21= (-t*(h-k) - g*l*(h**2-k**2)/2. - g*u*k**2*y/2. - 
     &            (y-1.)*g*u*k**3*phi/(6.*n))/(r*phi)

         B22= g*((h+k*(y-1.))/phi + (y-1.)*k**2/(2.*n))

         AL1= (B21+B1*A21)/(1.-A1*B1)
         AL2=(B22+B1*A22)/(1.-A1*B1)

         DE1= (A21+A1*B21)/(1.-A1*B1)
         DE2=(A22+A1*B22)/(1.-A1*B1)

! slope of sea surface (numerator first)
!
      top= x-(v*(DE1+g*k**3*u/(24.*n*r)) + w*AL1*(1.+phi*(h-k)/(2.*n)) + 
     &          w*(h-k)**2*(g*l*(3.*h+k) + 4.*t)/(24.*r*n))
!
! now denominator
!
      bot= w*(AL2*(1.+phi*(h-k)/(2.*n)) - g*(h-k)**2/(6.*n)) + 
     &v*(DE2-g*k**2/(6.*n))
!
! surface slope
!
      i= top/bot
!
! compute lower and upper layer velocities
!
      a= AL1+i*AL2
      d=DE1+i*DE2

      p= a*(1.+phi*(h-k)/(2.*n)) + (h-k)**2*(g*((3.*h+k)*l-4.*i*r) 
     &+ 4.*t)/(24.*r*n)

      q= d + g*k**2*(k*u-4.*i*r)/(24.*r*n)

!
! lower layer velocity
!
      uu(2,j)=p
!
! upper layer velocity
!
!
      uu(1,j)=q

!
! use velocities to derive volume transport (m3/s)
!
! first blank out point 45
!
         uu(1,45)=0.
         uu(2,45)=0.
         qu(1,j)=au(1,j)*uu(1,j)
         qu(2,j)=au(2,j)*uu(2,j)
!
! check volume conservation
!
	  if (abs((qu(1,j)+qu(2,j))-qau(j)).gt.(1.0e-6)*abs(qau(j))) then
           pause 'error in flow.m (the Officer equations)'
        endif
 500  continue
!
! compute vertical flows
!
      qw(1)=qu(1,1)-qrivp(1,1)+aw(1,1)*(qevapp(1)-qprecipp(1))
      do 600 j=2,51
         qw(j)=qu(1,j)-qu(1,j-1)-qrivp(1,j)+aw(1,j)*
     &                   (qevapp(j)-qprecipp(j))
         if (j.eq.19) then
            qw(19)=qw(19)-qu(1,50)
         endif
 600  continue
      qw(46)=0.
!
! end function flows

      return
      end





      subroutine den_grad(dengradu,deltxu,deltxp,denp)

      real*8 dengradu(2,51), deltxu(51), deltxp(51), 
     &        denp(2,51), tempgradu(2,51)
!
! usage: [dengradu]=den_grad(deltxu,deltxp,denp);
!
! computes density gradients, dengradu, at the u-section upper and
! lower interfaces between segments of the model estuary given density,
! denp, at p-sections. Some tidal excursion smoothing is emulated by
! smoothing the gradients over nearest-neighbour points
!
! see also: salmodel, tide_var, tide_av, mix_coef, flows, den_grad, salsolve,
! mass_chk, plot_run, month_av

!
! First compute longitudinal density gradient using the 2 nearest
! 'p' points around the 'u' point. Note that the gradient at point 51
! is zero (no flux into coast). First initialize gradient:
!
      dengradu(1,51) = 0.
      dengradu(2,51) = 0.
!
! South Bay through to Delta and Ocean limb to GG
!
      do 100 j=1,49
         dengradu(1,j)=(denp(1,j+1)-denp(1,j))/deltxu(j)
         dengradu(2,j)=(denp(2,j+1)-denp(2,j))/deltxu(j)
 100  continue
!
! Redefine Delta point 45 and define Angel Island point 50
!
      dengradu(1,45)=0.
      dengradu(2,45)=0.
      dengradu(1,50)=(denp(1,19)-denp(1,50))/deltxu(50)
      dengradu(2,50)=(denp(2,19)-denp(2,50))/deltxu(50)
!
! smooth the gradients (use inverse weighting, ie 1:2:1 for equispacing)
!
      do 200 i=1,51
         tempgradu(1,i)=dengradu(1,i)
         tempgradu(2,i)=dengradu(2,i)
 200  continue

      do 300 j=2,50
         tempgradu(1,j)=0.5*(dengradu(1,j)+dengradu(1,j-1)/
     &                     (1.+deltxp(j)/deltxp(j+1))+dengradu(1,j+1)/
     &                          (1.+deltxp(j+1)/deltxp(j)))
         tempgradu(2,j)=0.5*(dengradu(2,j)+dengradu(2,j-1)/
     &                     (1.+deltxp(j)/deltxp(j+1))+dengradu(2,j+1)/
     &                          (1.+deltxp(j+1)/deltxp(j)))
 300  continue
!
! redefine coastal ocean point 46 and Delta point 45
! 
      tempgradu(1,46)=dengradu(1,46)
      tempgradu(2,46)=dengradu(2,46)
      tempgradu(1,45)=dengradu(1,45)
      tempgradu(2,45)=dengradu(2,45)

      do 400 i=1,51
         dengradu(1,i)=tempgradu(1,i)
         dengradu(2,i)=tempgradu(2,i)
 400  continue
!
! end function den_grad

      return
      end